Codeforces Round 950 (Div. 3) A B

2024-06-04 20:28
文章标签 codeforces round div 950

本文主要是介绍Codeforces Round 950 (Div. 3) A B,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

A. Problem Generator

time limit per test: 1 second
memory limit per test: 256 megabytes
input: standard input
output: standard output

Vlad is planning to hold m m m rounds next month. Each round should contain one problem of difficulty levels ‘A’, ‘B’, ‘C’, ‘D’, ‘E’, ‘F’, and ‘G’.

Vlad already has a bank of n n n problems, where the i i i-th problem has a difficulty level of a i a_i ai. There may not be enough of these problems, so he may have to come up with a few more problems.

Vlad wants to come up with as few problems as possible, so he asks you to find the minimum number of problems he needs to come up with in order to hold m m m rounds.

For example, if m = 1 m=1 m=1, n = 10 n = 10 n=10, a = a= a= ‘BGECDCBDED’, then he needs to come up with two problems: one of difficulty level ‘A’ and one of difficulty level ‘F’.

Input

The first line contains a single integer t t t ( 1 ≤ t ≤ 1000 1 \le t \le 1000 1t1000) — the number of test cases.

The first line of each test case contains two integers n n n and m m m ( 1 ≤ n ≤ 50 1 \le n \le 50 1n50, 1 ≤ m ≤ 5 1 \le m \le 5 1m5) — the number of problems in the bank and the number of upcoming rounds, respectively.

The second line of each test case contains a string a a a of n n n characters from ‘A’ to ‘G’ — the difficulties of the problems in the bank.

Output

For each test case, output a single integer — the minimum number of problems that need to come up with to hold m m m rounds.

Example

i n p u t \tt input input
3
10 1
BGECDCBDED
10 2
BGECDCBDED
9 1
BBCDEFFGG
o u t p u t \tt output output
2
5
1

Tutorial

ABCDEFG 7 7 7 个字母在字符串 a a a 中如果出现次数不足 m m m 个则补齐,否则不做任何操作,则答案为 ∑ c = ′ A ′ ′ G ′ m − c n t c \sum_{c = 'A'}^{'G'} m - cnt_c c=AGmcntc

此解法时间复杂度为 O ( n ) \mathcal O(n) O(n)

Solution

for _ in range(int(input())):n, m = map(int, input().split())s = input()ss = "ABCDEFG"print(sum(max(0, m - s.count(ss[i])) for i in range(7)))

B. Choosing Cubes

time limit per test: 1 second
memory limit per test: 256 megabytes
input: standard input
output: standard output

Dmitry has n n n cubes, numbered from left to right from 1 1 1 to n n n. The cube with index f f f is his favorite.

Dmitry threw all the cubes on the table, and the i i i-th cube showed the value a i a_i ai ( 1 ≤ a i ≤ 100 1 \le a_i \le 100 1ai100). After that, he arranged the cubes in non-increasing order of their values, from largest to smallest. If two cubes show the same value, they can go in any order.

After sorting, Dmitry removed the first k k k cubes. Then he became interested in whether he removed his favorite cube (note that its position could have changed after sorting).

For example, if n = 5 n=5 n=5, f = 2 f=2 f=2, a = [ 4 , 3 , 3 , 2 , 3 ] a = [4, \color{green}3, 3, 2, 3] a=[4,3,3,2,3] (the favorite cube is highlighted in green), and k = 2 k = 2 k=2, the following could have happened:

  • After sorting a = [ 4 , 3 , 3 , 3 , 2 ] a=[4, \color{green}3, 3, 3, 2] a=[4,3,3,3,2], since the favorite cube ended up in the second position, it will be removed.
  • After sorting a = [ 4 , 3 , 3 , 3 , 2 ] a=[4, 3, \color{green}3, 3, 2] a=[4,3,3,3,2], since the favorite cube ended up in the third position, it will not be removed.

Input

The first line contains an integer t t t ( 1 ≤ t ≤ 1000 1 \le t \le 1000 1t1000) — the number of test cases. Then follow the descriptions of the test cases.

The first line of each test case description contains three integers n n n, f f f, and k k k ( 1 ≤ f , k ≤ n ≤ 100 1 \le f, k \le n \le 100 1f,kn100) — the number of cubes, the index of Dmitry’s favorite cube, and the number of removed cubes, respectively.

The second line of each test case description contains n n n integers a i a_i ai ( 1 ≤ a i ≤ 100 1 \le a_i \le 100 1ai100) — the values shown on the cubes.

Output

For each test case, output one line — “YES” if the cube will be removed in all cases, “NO” if it will not be removed in any case, “MAYBE” if it may be either removed or left.

You can output the answer in any case. For example, the strings “YES”, “nO”, “mAyBe” will be accepted as answers.

Example

i n p u t \tt input input
12
5 2 2
4 3 3 2 3
5 5 3
4 2 1 3 5
5 5 2
5 2 4 1 3
5 5 5
1 2 5 4 3
5 5 4
3 1 2 4 5
5 5 5
4 3 2 1 5
6 5 3
1 2 3 1 2 3
10 1 1
1 1 1 1 1 1 1 1 1 1
1 1 1
42
5 2 3
2 2 1 1 2
2 1 1
2 1
5 3 1
3 3 2 3 2
o u t p u t \tt output output
MAYBE
YES
NO
YES
YES
YES
MAYBE
MAYBE
YES
YES
YES
NO

Tutorial

在解决问题前可以先选中 Dmitry 所喜爱的 cube,记为 t a r g e t target target,然后对所有 cube 进行排序,如果 t a r g e t < a k target < a_k target<ak,则最喜欢的那个 cube 必定在前 k k k 个 cube 里,如果 t a r g e t > a k target > a_k target>ak,则最喜欢的那个 cube 必定不在前 k k k 个 cube 里,如果 t a r g e t = a k target = a_k target=ak,如果第 a k + 1 a_{k + 1} ak+1 的数值和 t a r g e t target target 相等,则说明 t a r g e t target target 有可能被移除,否则 t a r g e t target target 也是必定被移除

此解法时间复杂度为 O ( n log ⁡ n ) \mathcal O(n \log n) O(nlogn),即排序的时间复杂度

Solution

import sys
input = lambda: sys.stdin.readline().strip()
mod = 10 ** 9 + 7 # 998244353for _ in range(int(input())):n, f, k = map(int, input().split())a = list(map(int, input().split()))if k >= n:print("YES")continuetarget = a[f - 1]a.sort(reverse = True)if target > a[k - 1]:print("YES")elif target < a[k - 1]:print("NO")else:print("YES" if k == n or a[k] != target else "MAYBE")

这篇关于Codeforces Round 950 (Div. 3) A B的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1031034

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

CF#271 (Div. 2) D.(dp)

D. Flowers time limit per test 1.5 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/474/problem/D We s

CF #278 (Div. 2) B.(暴力枚举+推导公式+数学构造)

B. Candy Boxes time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/488/problem/B There